<?php
/*
Plugin Name: Geoportail-Shortcode
Description: Use API Geoportail in Wordpress
Version: 2.03
*/

include_once plugin_dir_path( __FILE__ ).'/Metabox.php';
include_once plugin_dir_path( __FILE__ ).'/Admin.php';
include_once plugin_dir_path( __FILE__ ).'/Install.php';
include_once plugin_dir_path( __FILE__ ).'/Form-Builder.php';
include_once plugin_dir_path( __FILE__ ).'/GPX.php';

register_activation_hook(__FILE__,'WP_GEO_install'); 
register_deactivation_hook( __FILE__, 'WP_GEO_remove');

add_action( 'wp_print_scripts', 'print_WP_GEO_scripts' );

function print_WP_GEO_scripts()
{
?>

	<style type="text/css">
		.entry-content img {max-width: 100000%; /* override */}
	</style>
	
	<!-- Form-Builder.js -->
	<script language="javascript" type="text/javascript" src=" <?php echo plugins_url('/js/Form-Builder.js', __FILE__); ?> "></script>
	<!-- Maps.js -->
	<script language="javascript" type="text/javascript" src=" <?php echo plugins_url('/js/Maps.js', __FILE__); ?> "></script>

<?php	
if(get_option('geomap_graph') == 'on')
{
?>
	<!-- jquery.flot -->
	<script language="javascript" type="text/javascript" src="http://people.iola.dk/olau/flot/jquery.js"></script>
	<script language="javascript" type="text/javascript" src="http://people.iola.dk/olau/flot/jquery.flot.js"></script>
	<script language="javascript" type="text/javascript" src=" <?php echo plugins_url('/js/Chart.js', __FILE__); ?> "></script>

<?php	
}

	if (get_option('geomap_key') != '' )
	{
?>
	<!-- get the API configuration, without the API javascript : -->
	<script type="text/javascript"
				src="http://api.ign.fr/geoportail/api?key=<?php echo get_option('geomap_key'); ?>&includeEngine=false&">
	</script>
	<script
		type="text/javascript"
		src="http://api.ign.fr/geoportail/api/js/<?php echo get_option('geomap_apiVersion'); ?>/GeoportalExtended.js">
	</script>
<?php	
	}
}
/******************************************************************************/
// geoportailme
/******************************************************************************/
function geoportailme($attr) {
	global $post;
/******************************************************************************/
// default atts
	$attr = shortcode_atts(
			array(	
				'lat'						=> get_option("geomap_lat"), 
				'lon'						=> get_option("geomap_lon"),
				'id'	 					=> '',
				'type'					=> get_option("geomap_type"), // normal ou mini
				'layers_array' 	=> get_option("geomap_layers_array"),
				'territory'			=> get_option("geomap_territory"),
				'z' 						=> get_option("geomap_z"),
				'w' 						=> get_option("geomap_w"),
				'h' 						=> get_option("geomap_h"),
				'kml_array'			=> '',
				'gpx_array'			=> '',
				'wms' 					=> '',
				'wms_layer'			=> '',
				'wms_title' 		=> 'couche_wms',
				'geolocate'			=> 'false',
				'geotag'				=> 'false',
				'gpx_graph'			=> 'false'
				), $attr);
/******************************************************************************/
	$post_id = $post->ID;
	$attr['id'] = 'geoportail_'. $post_id .'_'. $attr['id'];

	$returnme = '
		<style type="text/css">
			.entry-content img {max-width: 100000%; /* override */}

			div#map_'. $attr['id'] .' {
				background-color:white;
				background-image:url(http://api.ign.fr/geoportail/api/js/1.2/theme/geoportal/img/loading.gif);
				background-position:center center;
				background-repeat:no-repeat;
			}
		</style>
	';

/*************************************************************************/
	$returnme .= '
		<div id="geowp_'. $attr['id'] .'" style="clear:both;">
			<div id="map_'. $attr['id'] .'" style="width:' . $attr['w'] . 'px; height:' . $attr['h'] . 'px; "> </div>
	';
	if($attr['gpx_graph'] != 'false' && get_option('geomap_graph') == 'on')
	{
		$returnme .= '
	  	<div id="plot_'. $attr['id'] .'" style="margin-top:25px; width:' . $attr['w'] . 'px; height:250px;"> </div>
	  ';
	}
	$returnme .= '
		  <div class="entry-meta">
				<a href="http://wordpress.org/extend/plugins/geoportail-shortcode/"> Geoportail Shortcode </a>
			</div>
	  </div>

	';

////////////////////////////////////////////////////////////////////////////////
// Avanced Layers

	$layers_array = preg_split("/;/",$attr['layers_array'],-1,PREG_SPLIT_NO_EMPTY);
	$layers_js="";
	foreach( $layers_array as $layer )
	{
		if (gettype($layer)!==gettype(array()))
		{
			$layer = preg_split("/[\s|]+/",$layer,-1,PREG_SPLIT_NO_EMPTY);
		}
		
		if($layer[0] == "ortho")
		{
			$layer[0] = "ORTHOIMAGERY.ORTHOPHOTOS:WMSC";
		}
		if($layer[0] == "map")
		{
			$layer[0] = "GEOGRAPHICALGRIDSYSTEMS.MAPS:WMSC";
		}
		
		$visibility = 1;
		$opacity = 1;
		
		if (count($layer) >= 2)
		{
			if($layer[1] == 'on')
				$visibility =1;
			else
				$visibility =0;
		}
		if (count($layer) >= 3)
			$opacity = $layer[2];
		
		$layers_js .= '{name:"'.$layer[0].'", opacity:'.$opacity.', visibility:'.$visibility.'},';
	}
	// on supprime la dernière ","
	$layers_js = substr($layers_js,0,-1);

////////////////////////////////////////////////////////////////////////////////
//kml_array

		$kml_array_js="";
		if($attr['kml_array'] != '') 
		{	
			if (gettype($attr['kml_array'])!==gettype(array()))
			{
				$attr['kml_array'] = preg_split("/;/",$attr['kml_array'],-1,PREG_SPLIT_NO_EMPTY);
			}
			foreach( $attr['kml_array'] as $kml )
			{
				if (gettype($kml)!==gettype(array()))
					$kml = preg_split("/,/",$kml,-1,PREG_SPLIT_NO_EMPTY);
				if (count($kml) == 1)
					$kml[]='KML_Layer';
				if (count($kml) == 2)
					$kml_array_js .= '{name:"'.$kml[1].'",url:"'.$kml[0].'"},';
			}
			// on supprime la dernière ","
			$kml_array_js = substr($kml_array_js,0,-1); 
		}
////////////////////////////////////////////////////////////////////////////////
//gpx_array
		$gpx_array_js="";
		if($attr['gpx_array'] != '') 
		{
			if (gettype($attr['gpx_array'])!==gettype(array()))
				$attr['gpx_array'] = preg_split("/;/",$attr['gpx_array'],-1,PREG_SPLIT_NO_EMPTY);

			foreach( $attr['gpx_array'] as $gpx )
			{
				if (gettype($gpx)!==gettype(array()))
					$gpx = preg_split("/,/",$gpx,-1,PREG_SPLIT_NO_EMPTY);
				
				if($attr['gpx_graph'] != 'false' && get_option('geomap_graph') == 'on')
					$gpx_parse .= parseGPX($gpx[0]);
				
				if (count($gpx) == 1)
					$gpx[]='GPX_Layers';

				if (count($gpx) == 2)
					$gpx_array_js.= '{name:"'.$gpx[1].'",url:"'.$gpx[0].'"},';

			}
			// on supprime la dernière ","
			$gpx_array_js = substr($gpx_array_js,0,-1);
			if($gpx_parse!= '')
				$gpx_parse ='geowp_chart(['.$gpx_parse.'],"'.$attr['id'].'")';
		}
////////////////////////////////////////////////////////////////////////////////
//wms
//TODO
/*
		if($attr['wms'] != '') 
		{
			$returnme .= '
					map.addLayer(
						"WMS",
						"' . $attr['wms_title'] . '",
						"' . $attr['wms'] . '",
	                		   	{layers: "' . $attr['wms_layer'] . '"},
		                   		{transitionEffect: "resize"}	
					);
			';
		}
*/
////////////////////////////////////////////////////////////////////////////////
//geotags
	$geotag_js='{"enabled":"false"}';
	if($attr['geotag'] != 'false')
	{
		$post_id = $post->ID;
		$lon = get_post_meta($post_id, 'geo_longitude', true);
		$lat = get_post_meta($post_id, 'geo_latitude', true);
		// geo_public geo_enabled
		$geo_public = get_post_meta($post_id, 'geo_public', true);
		$geo_enabled = get_post_meta($post_id, 'geo_enabled', true);
		if ($geo_public == '1' && $geo_enabled =='1')
		{
			$geotag_js='{enabled:"true",lat:"'.$lat.'",lon:"'.$lon.'"}';
		}
	}
////////////////////////////////////////////////////////////////////////////////
//TODO : wms ...
	$returnme .= '
		<script type="text/javascript">
			jQuery(document).ready(function() {
				create_map({
					id				: "'.$attr['id'].'",
					type			: "'.$attr['type'].'",
					lat				: "'.$attr['lat'].'",
					lon				: "'.$attr['lon'].'",
					z				: '.$attr['z'].',
					territory		: "'.$attr['territory'].'",
					geolocate		: "'.$attr['geolocate'].'",
					geotag			: '.$geotag_js.',
					layers_array	: ['.$layers_js.'],
					kml_array 		: ['.$kml_array_js.'],
					gpx_array		: ['.$gpx_array_js.']
				});

				'.$gpx_parse.'

			});
		</script>';
	return $returnme;
}

add_shortcode('geoportail', 'geoportailme');

?>
